﻿Imports System.Text

Module Module1
    Private Sub EventFun(command As UInt16, result As UInt16, ByRef msg As UInt16, length As Integer)
    End Sub
    Public callback As HRobot.CallBackFun = New CallBackFun(AddressOf EventFun)
    Public device_id As Integer
    Sub Main()
        Dim SDK_ver As StringBuilder = New StringBuilder()
        Dim HRS_ver As StringBuilder = New StringBuilder()
        HRobot.get_hrsdk_version(SDK_ver)
        Console.WriteLine("SDK version: " & SDK_ver.ToString())
        device_id = HRobot.open_connection("127.0.0.1", 1, callback)
        If (device_id >= 0) Then
            HRobot.get_hrss_version(device_id, HRS_ver)
            Console.WriteLine("HRS version: " & HRS_ver.ToString())
            Console.WriteLine("connect successful.")
            SetRobotParameter(device_id, callback)
        Else
            Console.WriteLine("connect failure.")
        End If

        Console.WriteLine(" Press ""Enter"" key to quit the program.")
        Console.ReadLine()
        HRobot.disconnect(device_id)
    End Sub

    Sub string2ushort(str As String, new_commet As UShort())
        For i As Integer = 0 To str.Length - 1
            new_commet(i) = Convert.ToUInt16(str(i))
        Next
    End Sub

    Sub SetRobotParameter(device_id As Integer, callback As HRobot.CallBackFun)
        If (device_id >= 0) Then
            Dim rlt As Integer
            rlt = HRobot.set_operation_mode(device_id, 1)
            Dim robot_id As StringBuilder = New StringBuilder("HrSs_Robot_ID")
            rlt = HRobot.set_robot_id(device_id, robot_id)
            rlt = HRobot.set_acc_dec_ratio(device_id, 50)
            rlt = HRobot.set_acc_time(device_id, 250)
            rlt = HRobot.set_operation_mode(device_id, 0)
            rlt = HRobot.set_operation_mode(device_id, 1)
            rlt = HRobot.set_override_ratio(device_id, 50)
            rlt = HRobot.set_ptp_speed(device_id, 50)
            rlt = HRobot.set_lin_speed(device_id, 800)
            rlt = HRobot.set_command_id(device_id, 10)
            rlt = HRobot.set_digital_output(device_id, 5, True)
            rlt = HRobot.set_robot_output(device_id, 5, True)
            rlt = HRobot.set_valve_output(device_id, 1, True)
            rlt = HRobot.set_base_number(device_id, 5)
            rlt = HRobot.set_tool_number(device_id, 5)
            rlt = HRobot.set_timer(device_id, 5, 1000)
            Dim timer_name(50) As UShort
            string2ushort("Timer commnet", timer_name)
            rlt = HRobot.set_timer_name(device_id, 5, timer_name)
            rlt = HRobot.set_timer_start(device_id, 5)
            rlt = HRobot.set_timer_stop(device_id, 5)
            rlt = HRobot.set_counter(device_id, 5, 1000)
            rlt = HRobot.set_pr_type(device_id, 5, 1000)
            Dim coor() As Double = {0, 0, 0, 0, -90, 0}
            Dim ext_pos() As Double = {0, 0, 0}
            rlt = HRobot.set_pr_coordinate(device_id, 5, coor)
            Dim tool_base() As Double = {5, 5}
            rlt = HRobot.set_pr_coordinate(device_id, 5, tool_base)
            rlt = HRobot.define_base(device_id, 5, coor)
            rlt = HRobot.define_tool(device_id, 5, coor)
            rlt = HRobot.set_pr(device_id, 5, 1, coor, ext_pos, 5, 5)
            rlt = HRobot.set_pr_tool_base(device_id, 5, 2, 2)
            Dim pr_comment(50) As UShort
            string2ushort("PR commnet", pr_comment)
            rlt = HRobot.set_pr_comment(device_id, 5, pr_comment)
            rlt = HRobot.remove_pr(device_id, 5)
            rlt = HRobot.set_smooth_length(device_id, 200)
            Dim rsr As String = "set_rsr.hrb"
            rlt = HRobot.set_rsr(device_id, rsr, 1)
            rlt = HRobot.remove_rsr(device_id, 1)
            rlt = HRobot.set_motor_state(device_id, 1)
            rlt = HRobot.set_operation_mode(device_id, 1)
            rlt = HRobot.remove_command(device_id, 1)
            rlt = HRobot.remove_command_tail(device_id, 1)

            'Module I/O
            rlt = HRobot.set_module_input_simulation(device_id, 5, True)
            rlt = HRobot.set_module_input_value(device_id, 5, True)
            rlt = HRobot.set_module_input_start(device_id, 5, 1)
            rlt = HRobot.set_module_input_end(device_id, 5, 5)
            Dim mi_comment(50) As UShort
            string2ushort("MI commnet", mi_comment)
            rlt = HRobot.set_module_input_comment(device_id, 5, mi_comment)
            rlt = HRobot.set_module_output_value(device_id, 5, True)
            rlt = HRobot.set_module_output_start(device_id, 5, 1)
            rlt = HRobot.set_module_output_end(device_id, 5, 5)
            Dim mo_comment(50) As UShort
            string2ushort("MO commnet", mo_comment)
            rlt = HRobot.set_module_output_comment(device_id, 5, mo_comment)


            ''' New 2020.03.19
            Dim Str As StringBuilder = New StringBuilder("test text")
            Dim DIO_comment(50) As UShort
            Dim DIO As Integer = 0
            Dim SIO As Integer = 1
            Dim data() As Integer = {DIO, 34, DIO, 35, SIO, 36, SIO, 37, DIO, 38, SIO, 39, DIO, 40, DIO, 41, DIO, 42}
            Dim ON_ As Boolean = True

            string2ushort("DIO commnet", DIO_comment)
            rlt = HRobot.set_DI_simulation_Enable(device_id, 5, ON_)
            rlt = HRobot.set_DI_simulation(device_id, 5, ON_)
            rlt = HRobot.set_digital_input_comment(device_id, 5, DIO_comment)
            rlt = HRobot.set_digital_output_comment(device_id, 5, DIO_comment)
            Dim joint() As Double = {0, 0, 0, 0, 0, 0}
            rlt = HRobot.set_home_point(device_id, joint)
            rlt = HRobot.set_module_input_type(device_id, 5, 0)
            rlt = HRobot.set_module_output_type(device_id, 5, 1)
            Dim counter_name(50) As UShort
            string2ushort("Counter commnet", counter_name)
            rlt = HRobot.set_counter_name(device_id, 5, counter_name)

            rlt = HRobot.set_digital_setting(device_id, data, Str)
            rlt = HRobot.set_user_alarm_setting_message(device_id, 5, Str)
            rlt = HRobot.set_language(device_id, 0)
            rlt = HRobot.save_module_io_setting(device_id)

            ' payload
            Dim Index As Integer = 4
            Dim mass As Double = 2
            Dim Xcc As Double = 2.1
            Dim Ycc As Double = 2.2
            Dim Zcc As Double = 2.3
            Dim Ixx As Double = 2.4
            Dim Iyy As Double = 2.5
            Dim Izz As Double = 2.6
            Dim value() As Double = {mass, Xcc, Ycc, Zcc, Ixx, Iyy, Izz}
            Dim payload_comment = New StringBuilder("payload comment")
            rlt = HRobot.set_payload_config(device_id, Index, value, payload_comment)
            rlt = HRobot.set_payload_active(device_id, Index)

        Else
            Console.WriteLine("connect failure.")
        End If

    End Sub



End Module
